<template>
    <div class="login">
        <form
                class="login-form"
                id="app"
                @submit="checkFormAndLogin"
        >
            <div class="login-card">
                <h2 class="text-light">Login/Register</h2>
                <label class="light">Name</label>
                <input class="light" name="name" type="text" placeholder="Enter your username" v-model="name"/>
                <label class="light">Password</label>
                <input class="light" name="name" type="password" placeholder="Enter your password" v-model="password"/>
                <button class="btn btn-light">Login</button>
                <button class="btn btn-light" v-on:click="checkFormAndRegister">Register</button>
            </div>
            <div v-if="errors.length">
                <b>Please correct the following error(s):</b>
                <ul>
                    <li v-for="error in errors" v-bind:key="error">{{ error }}</li>
                </ul>
            </div>
        </form>
    </div>
</template>

<script>
    import WS from '../../websocket_con'
    import { store, mutations } from '../../store'

    export default {
        name: 'LoginRegister',
        data() {
            return {
                errors: [],
                name: '',
                password: '',
            }
        },
        methods: {
            checkFormAndLogin: function (event) {
                event.preventDefault();
                this.errors = [];
                if (!this.name) {
                    this.errors.push('Please enter a valid name')
                }
                if (!this.password) {
                    this.errors.push('Please enter a valid password')
                }
                if (this.errors.length === 0) {
                    WS.send(JSON.stringify({action: 'login', username: this.name, password: this.password}));

                    console.log(store.logged_in)
                }
            },
            checkFormAndRegister: function (event) {
                event.preventDefault();
                this.errors = [];
                if (!this.name) {
                    this.errors.push('Please enter a valid name')
                }
                if (!this.password) {
                    this.errors.push('Please enter a valid password')
                }
                if (this.errors.length === 0) {
                    WS.send(JSON.stringify({action: 'register', username: this.name, password: this.password}));
                    this.$router.push('dashboard')
                }
            },
        }
    }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
    @import "../../assets/theme";

    .login-card {
        max-width: 400px;
        margin-left: auto;
        margin-right: auto;
        display: flex;
        flex-direction: column;
    }

    .login {
        height: calc(100vh - 45px);
        padding: 40px;
        display: flex;

        form.login-form {
            background-color: $PRIMARY-COLOUR;
            margin: 0;
            height: 100%;
            width: 100%;
            padding: 20px;
        }
    }


</style>
